cookutils annotate cook @ rev 137

cook: dont build WANTED id it's broken
author Christophe Lincoln <pankso@slitaz.org>
date Wed May 11 04:02:30 2011 +0200 (2011-05-11)
parents c83f48dace63
children c36985230ddb
rev   line source
pankso@1 1 #!/bin/sh
pankso@1 2 #
pankso@1 3 # Cook - A tool to cook and generate SliTaz packages. Read the README
pankso@1 4 # before adding or modifing any code in cook!
pankso@1 5 #
pankso@1 6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
pankso@1 7 # Author: Christophe Lincoln <pankso@slitaz.org>
pankso@1 8 #
pankso@1 9
pankso@1 10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
pankso@1 11 [ -f "cook.conf" ] && . ./cook.conf
pankso@1 12
pankso@16 13 # Share DB and status with the Cooker.
pankso@9 14 activity="$CACHE/activity"
pankso@16 15 command="$CACHE/command"
pankso@11 16 broken="$CACHE/broken"
pankso@47 17 blocked="$CACHE/blocked"
pankso@9 18
pankso@1 19 #
pankso@1 20 # Functions
pankso@1 21 #
pankso@1 22
pankso@1 23 usage() {
pankso@1 24 cat << EOT
pankso@1 25
pankso@1 26 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command|list] [--option]
pankso@1 27
pankso@1 28 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
pankso@1 29 usage|help $(gettext "Display this short usage.")
pankso@1 30 setup $(gettext "Setup your build environment.")
pankso@9 31 test $(gettext "Test environment and cook a package.")
pankso@69 32 list-wok $(gettext "List packages in the wok.")
pankso@69 33 search $(gettext "Simple packages search function.")
paul@62 34 new $(gettext "Create a new package with a receipt".)
pankso@1 35 list $(gettext "Cook a list of packages.")
pankso@1 36 clean-wok $(gettext "Clean-up all packages files.")
paul@62 37 clean-src $(gettext "Clean-up all packages sources.")
pankso@1 38 pkglist $(gettext "Create all packages.* lists.")
pankso@1 39
pankso@1 40 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
pankso@10 41 --clean|-c Cook : $(gettext "clean the package in the wok.")
pankso@39 42 --install|-i Cook : $(gettext "cook and install the package.")
pankso@39 43 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
pankso@49 44 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
pankso@49 45 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
pankso@10 46 --wok|-w Setup: $(gettext "create also a wok from Hg repo.")
pankso@1 47
pankso@1 48 EOT
pankso@1 49 exit 0
pankso@1 50 }
pankso@1 51
paul@62 52 # Be sure we're root.
pankso@1 53 check_root() {
pankso@1 54 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
pankso@1 55 }
pankso@1 56
pankso@1 57 separator() {
pankso@1 58 echo "================================================================================"
pankso@1 59 }
pankso@1 60
pankso@1 61 status() {
pankso@1 62 echo -en "\\033[70G[ "
pankso@1 63 if [ $? = 0 ]; then
pankso@1 64 echo -en "\\033[1;32mOK"
pankso@1 65 else
pankso@1 66 echo -en "\\033[1;31mFailed"
pankso@1 67 fi
pankso@1 68 echo -e "\\033[0;39m ]"
pankso@1 69 }
pankso@1 70
pankso@13 71 # Log activities, we want first letter capitalized.
pankso@9 72 log() {
pankso@27 73 grep ^[A-Z] | \
pankso@9 74 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
pankso@9 75 }
pankso@9 76
paul@62 77 # We don't want these escapes in web interface.
pankso@1 78 clean_log() {
pankso@1 79 sed -i -e s'|\[70G\[ \[1;32m| |' \
pankso@1 80 -e s'|\[0;39m \]||' $LOGS/$pkg.log
pankso@1 81 }
pankso@1 82
pankso@23 83 # Log broken packages.
pankso@23 84 broken() {
pankso@74 85 if ! grep -q "^$pkg$" $broken; then
pankso@74 86 echo "$pkg" >> $broken
pankso@74 87 fi
pankso@23 88 }
pankso@23 89
paul@62 90 # Be sure package exists in wok.
pankso@1 91 check_pkg_in_wok() {
pankso@1 92 if [ ! -d "$WOK/$pkg" ]; then
pankso@1 93 gettext -e "\nUnable to find package in the wok:"
pankso@1 94 echo -e " $pkg\n" && exit 1
pankso@1 95 fi
pankso@1 96 }
pankso@1 97
pankso@9 98 if_empty_value() {
pankso@9 99 if [ -z "$value" ]; then
pankso@9 100 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
pankso@9 101 exit 1
pankso@9 102 fi
pankso@9 103 }
pankso@9 104
paul@62 105 # Initialize files used in $CACHE
pankso@52 106 init_db_files() {
pankso@52 107 gettext "Creating directories structure in:"; echo " $SLITAZ"
pankso@52 108 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
pankso@52 109 gettext "Creating DB files in:"; echo " $CACHE"
pankso@52 110 for f in $activity $command $broken $blocked
pankso@52 111 do
pankso@52 112 touch $f
pankso@52 113 done
pankso@52 114 }
pankso@52 115
paul@62 116 # QA: check a receipt consistency before building.
pankso@9 117 receipt_quality() {
pankso@9 118 gettext -e "QA: checking package receipt...\n"
pankso@9 119 unset online
pankso@9 120 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
pankso@9 121 online="online"
pankso@9 122 fi
pankso@9 123 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
pankso@9 124 do
pankso@9 125 unset value
pankso@44 126 value=$(grep ^$var= $receipt | cut -d \" -f 2)
pankso@9 127 case "$var" in
pankso@9 128 PACKAGE|VERSION|SHORT_DESC)
pankso@9 129 if_empty_value ;;
pankso@9 130 CATEGORY)
pankso@9 131 [ -z "$value" ] && value="empty"
pankso@9 132 valid="base-system x-window utilities network graphics \
pankso@9 133 multimedia office development system-tools security games \
pankso@9 134 misc meta non-free"
pankso@9 135 if ! echo "$valid" | grep -q -w "$value"; then
paul@62 136 gettext "QA: unknown category:"; echo -e " $value\n"
pankso@9 137 exit 1
pankso@9 138 fi ;;
pankso@9 139 WEB_SITE)
paul@62 140 # We don't check WGET_URL since if dl is needed it will fail.
paul@62 141 # Break also if we're not online. Here error is not fatal.
pankso@9 142 if_empty_value
pankso@9 143 [ -z "$online" ] || break
pankso@9 144 if ! busybox wget -s $value 2>/dev/null; then
pankso@61 145 gettext "QA: Unable to reach:"; echo -e " $value"
pankso@9 146 fi ;;
pankso@9 147 esac
pankso@9 148 done
pankso@9 149 }
pankso@9 150
pankso@9 151 # Executed before sourcing a receipt.
pankso@9 152 unset_receipt() {
pankso@9 153 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
pankso@9 154 }
pankso@9 155
paul@62 156 # Paths used in receipt and by cook itself.
pankso@1 157 set_paths() {
pankso@1 158 pkgdir=$WOK/$PACKAGE
pankso@1 159 src=$pkgdir/source/$PACKAGE-$VERSION
pankso@44 160 taz=$pkgdir/taz
pankso@44 161 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
pankso@1 162 fs=$pack/fs
pankso@1 163 stuff=$pkgdir/stuff
pankso@1 164 install=$pkgdir/install
pankso@1 165 if [ "$WANTED" ]; then
pankso@1 166 src=$WOK/$WANTED/source/$WANTED-$VERSION
pankso@1 167 install=$WOK/$WANTED/install
pankso@121 168 wanted_stuff=$WOK/$WANTED/stuff
pankso@1 169 fi
pankso@9 170 # Old way compatibility.
pankso@1 171 _pkg=$install
pankso@1 172 }
pankso@1 173
pankso@9 174 # Get package source.
pankso@1 175 get_source() {
pankso@115 176 pwd=$(pwd)
pankso@9 177 case "$WGET_URL" in
pankso@9 178 http://*|ftp://*)
pankso@9 179 # Busybox Wget is better!
pankso@15 180 busybox wget -c -P $SRC $WGET_URL || \
pankso@15 181 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@9 182 hg*|mercurial*)
pankso@9 183 # We are in cache so clone here and create a tarball
pankso@29 184 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
pankso@9 185 url=${WGET_URL#hg|}
pankso@9 186 else
pankso@9 187 url=${WGET_URL#mercurial|}
pankso@9 188 fi
pankso@10 189 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
pankso@9 190 tarball=$pkgsrc.tar.bz2
pankso@61 191 gettext -e "Getting source from Hg...\n"
pankso@61 192 echo "URL: $url"
pankso@9 193 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
pankso@15 194 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
pankso@9 195 gettext "Creating tarball: "; echo "$tarball"
pankso@9 196 tar cjf $tarball $pkgsrc || exit 1
pankso@9 197 mv $tarball $SRC && rm -rf $pkgsrc ;;
pankso@9 198 git*)
pankso@61 199 url=${WGET_URL#git|}
pankso@61 200 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
pankso@61 201 tarball=$pkgsrc.tar.bz2
pankso@61 202 gettext -e "Getting source from Git...\n"
pankso@61 203 echo "URL: $url"
pankso@64 204 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
pankso@63 205 if [ "$BRANCH" ]; then
pankso@64 206 cd $pkgsrc && git checkout $BRANCH && cd ..
pankso@63 207 fi
pankso@61 208 gettext "Creating tarball: "; echo "$tarball"
pankso@61 209 tar cjf $tarball $pkgsrc || exit 1
pankso@61 210 mv $tarball $SRC && rm -rf $pkgsrc ;;
pankso@69 211 svn*|subversion*)
pankso@9 212 echo "TODO: svn implementation in cook" && exit 1 ;;
pankso@9 213 *)
pankso@9 214 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
pankso@9 215 tee -a $LOGS/$PACKAGE.log
pankso@9 216 exit 1 ;;
pankso@9 217 esac
pankso@1 218 }
pankso@1 219
pankso@9 220 # Extract source package.
pankso@1 221 extract_source() {
pankso@1 222 gettext "Extracting:"; echo " $TARBALL"
pankso@1 223 case "$TARBALL" in
pankso@120 224 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
pankso@120 225 *.tar.bz2|*.tbz) tar xjf $SRC/$TARBALL 2>/dev/null ;;
pankso@1 226 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
pankso@42 227 *.tar) tar xf $SRC/$TARBALL ;;
pankso@42 228 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
pankso@42 229 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
pankso@42 230 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
pankso@42 231 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
pankso@1 232 esac
pankso@1 233 }
pankso@1 234
pankso@9 235 # Display cooked package summary.
pankso@1 236 summary() {
pankso@1 237 cd $WOK/$pkg
pankso@1 238 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
pankso@1 239 fs=$(du -sh taz/* | awk '{print $1}')
pankso@44 240 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
pankso@44 241 files=$(cat taz/$pkg-*/files.list | wc -l)
pankso@18 242 cookdate=$(date "+%Y-%m-%d %H:%M")
pankso@101 243 sec=$time
pankso@104 244 div=$(($time / 60))
pankso@112 245 [ "$div" != 0 ] && min="~ ${div}m"
pankso@1 246 gettext "Summary for:"; echo " $PACKAGE $VERSION"
pankso@1 247 separator
pankso@67 248 [ "$prod" ] && echo "Produced : $prod"
pankso@1 249 cat << EOT
pankso@1 250 Packed : $fs
pankso@1 251 Compressed : $size
pankso@18 252 Files : $files
pankso@102 253 Cook time : ${sec}s $min
pankso@18 254 Cook date : $cookdate
pankso@1 255 $(separator)
pankso@1 256 EOT
pankso@1 257 }
pankso@1 258
paul@62 259 # Display debugging error info.
pankso@15 260 debug_info() {
pankso@17 261 echo -e "\nDebug information"
pankso@15 262 separator
pankso@48 263 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
pankso@76 264 for error in \
pankso@77 265 ERROR "No package" "cp: can't" "can't open" "can't cd" \
pankso@76 266 "error:" "fatal error:"
pankso@34 267 do
pankso@34 268 fgrep "$error" $LOGS/$pkg.log
pankso@34 269 done
pankso@15 270 separator && echo ""
pankso@15 271 }
pankso@15 272
pankso@1 273 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
pankso@1 274 # so some packages need to copy these files with the receipt and genpkg_rules.
pankso@1 275 copy_generic_files()
pankso@1 276 {
pankso@1 277 # $LOCALE is set in cook.conf
pankso@1 278 if [ "$LOCALE" ]; then
pankso@1 279 if [ -d "$_pkg/usr/share/locale" ]; then
pankso@1 280 mkdir -p $fs/usr/share/locale
pankso@1 281 for i in $LOCALE
pankso@1 282 do
pankso@1 283 if [ -d "$_pkg/usr/share/locale/$i" ]; then
pankso@1 284 cp -a $_pkg/usr/share/locale/$i $fs/usr/share/locale
pankso@1 285 fi
pankso@1 286 done
pankso@1 287 fi
pankso@1 288 fi
pankso@1 289
pankso@1 290 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
pankso@1 291 if [ "$GENERIC_PIXMAPS" != "no" ]; then
pankso@1 292 if [ -d "$_pkg/usr/share/pixmaps" ]; then
pankso@1 293 mkdir -p $fs/usr/share/pixmaps
pankso@1 294 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.png \
pankso@1 295 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 296 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.xpm \
pankso@1 297 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 298 fi
pankso@1 299
pankso@1 300 # Custom or homemade PNG pixmap can be in stuff.
pankso@1 301 if [ -f "$stuff/$PACKAGE.png" ]; then
pankso@1 302 mkdir -p $fs/usr/share/pixmaps
pankso@1 303 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
pankso@1 304 fi
pankso@1 305 fi
pankso@1 306
pankso@1 307 # Desktop entry (.desktop).
pankso@1 308 if [ -d "$_pkg/usr/share/applications" ]; then
pankso@1 309 cp -a $_pkg/usr/share/applications $fs/usr/share
pankso@1 310 fi
pankso@1 311
pankso@1 312 # Homemade desktop file(s) can be in stuff.
pankso@1 313 if [ -d "$stuff/applications" ]; then
pankso@1 314 mkdir -p $fs/usr/share
pankso@1 315 cp -a $stuff/applications $fs/usr/share
pankso@1 316 fi
pankso@1 317 if [ -f "$stuff/$PACKAGE.desktop" ]; then
pankso@1 318 mkdir -p $fs/usr/share/applications
pankso@1 319 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
pankso@1 320 fi
pankso@1 321 }
pankso@1 322
pankso@67 323 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
pankso@68 324 # as removing uneeded files like in Python packages.
pankso@1 325 strip_package()
pankso@1 326 {
pankso@67 327 gettext "Executing strip on all files..."
pankso@1 328 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
pankso@1 329 do
pankso@1 330 if [ -d "$dir" ]; then
pankso@1 331 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
pankso@1 332 fi
pankso@1 333 done
pankso@1 334 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
pankso@1 335 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
pankso@1 336 status
pankso@67 337
pankso@117 338 # Remove Python .pyc and .pyo from packages.
pankso@117 339 if echo "$DEPENDS" | fgrep -q "python"; then
pankso@68 340 gettext "Removing Python compiled files..."
pankso@67 341 find $fs -type f -name "*.pyc" -delete 2>/dev/null
pankso@67 342 find $fs -type f -name "*.pyo" -delete 2>/dev/null
pankso@117 343 status
pankso@117 344 fi
pankso@117 345
pankso@117 346 # Remove Perl perllocal.pod and .packlist from packages.
pankso@117 347 if echo "$DEPENDS" | fgrep -q "perl"; then
pankso@117 348 gettext "Removing Perl compiled files..."
pankso@67 349 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
pankso@67 350 find $fs -type f -name ".packlist" -delete 2>/dev/null
pankso@67 351 status
pankso@67 352 fi
pankso@1 353 }
pankso@1 354
pankso@8 355 # Remove installed deps.
pankso@8 356 remove_deps() {
pankso@8 357 # Now remove installed build deps.
pankso@113 358 diff="$CACHE/installed.cook.diff"
pankso@113 359 if [ -s "$CACHE/installed.cook.diff" ]; then
pankso@113 360 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
pankso@113 361 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@8 362 gettext "Build dependencies to remove:"; echo " $nb"
pankso@8 363 gettext "Removing:"
pankso@8 364 for dep in $deps
pankso@8 365 do
pankso@8 366 echo -n " $dep"
pankso@8 367 yes | tazpkg remove $dep >/dev/null
pankso@8 368 done
pankso@16 369 echo -e "\n"
pankso@113 370 # Keep the last diff for debug and info.
pankso@113 371 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
pankso@1 372 fi
pankso@1 373 }
pankso@1 374
pankso@1 375 # The main cook function.
pankso@1 376 cookit() {
pankso@11 377 echo "Cook: $PACKAGE $VERSION"
pankso@9 378 separator
pankso@1 379 set_paths
pankso@9 380 [ "$QA" ] && receipt_quality
pankso@44 381 cd $pkgdir
pankso@33 382 rm -rf install taz source
pankso@1 383
pankso@1 384 # Disable -pipe if less than 512Mb free RAM.
pankso@1 385 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
pankso@1 386 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
pankso@1 387 gettext -e "Disabling -pipe compile flag: $free RAM\n"
pankso@1 388 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
pankso@47 389 CXXFLAGS="${CXXFLAGS/-pipe}" && \
pankso@47 390 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
pankso@1 391 fi
pankso@1 392 unset free
pankso@1 393
pankso@1 394 # Export flags and path to be used by make
pankso@44 395 DESTDIR=$pkgdir/install
pankso@1 396 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS BUILD_HOST CONFIG_SITE
pankso@1 397 local LC_ALL=POSIX LANG=POSIX
pankso@1 398
pankso@126 399 # Check for build deps and handle implicit depends of *-dev packages
pankso@126 400 # (ex: libusb-dev :: libusb).
pankso@1 401 cd $INSTALLED && ls -1 > $CACHE/installed.list
pankso@1 402 [ "$DEPENDS" ] && gettext -e "Checking build dependencies...\n"
pankso@1 403 for dep in $BUILD_DEPENDS
pankso@1 404 do
pankso@126 405 implicit=${dep%-dev}
pankso@131 406 for i in $dep $implicit
pankso@126 407 do
pankso@131 408 if [ ! -f "$INSTALLED/$i/receipt" ]; then
pankso@126 409 # Try local package first.
pankso@131 410 vers=$(grep ^VERSION $WOK/$i/receipt | cut -d '"' -f 2)
pankso@131 411 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
pankso@131 412 gettext "Installing dep (pkg/local):"; echo " $i"
pankso@131 413 cd $PKGS && tazpkg install $i-$vers.tazpkg >/dev/null
pankso@126 414 else
pankso@131 415 gettext "Installing dep (web/cache):"; echo " $i"
pankso@131 416 tazpkg get-install $i >/dev/null
pankso@126 417 fi
pankso@1 418 fi
pankso@126 419 done
pankso@1 420 done
pankso@128 421 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
pankso@8 422
paul@62 423 # If a cook failed deps are not removed since we exit 1.
pankso@113 424 [ ! -s "installed.cook.diff" ] && \
pankso@113 425 diff installed.list installed.cook > installed.cook.diff
pankso@113 426 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@1 427
pankso@1 428 # Get source tarball and make sure we have source dir named:
paul@62 429 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
paul@62 430 # tarball if it exists.
pankso@1 431 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
pankso@1 432 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
pankso@10 433 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
pankso@1 434 else
pankso@1 435 get_source || exit 1
pankso@1 436 fi
pankso@1 437 fi
pankso@9 438 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
pankso@1 439 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
pankso@1 440 extract_source || exit 1
paul@62 441 # Some archives are not well done and don't extract to one dir (ex lzma).
pankso@57 442 files=$(ls | wc -l)
pankso@57 443 [ "$files" == 1 ] && mv * ../$PACKAGE-$VERSION
pankso@57 444 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
pankso@57 445 mv * ../$PACKAGE-$VERSION
pankso@1 446 cd .. && rm -rf tmp
pankso@1 447 fi
pankso@1 448
pankso@9 449 # Execute receipt rules.
pankso@44 450 if grep -q ^compile_rules $receipt; then
pankso@1 451 gettext -e "Executing: compile_rules\n"
pankso@55 452 [ -d "$src" ] && cd $src
pankso@97 453 compile_rules $@ || exit 1
pankso@10 454 # Stay compatible with _pkg
pankso@55 455 [ -d "$src/_pkg" ] && mv $src/_pkg $install
pankso@9 456 # QA: compile_rules success so valid.
pankso@9 457 mkdir -p $install
pankso@9 458 else
pankso@9 459 # QA: No compile_rules so no error, valid.
pankso@9 460 mkdir -p $install
pankso@1 461 fi
pankso@1 462 separator && echo ""
pankso@1 463 }
pankso@1 464
pankso@1 465 # Cook quality assurance.
pankso@1 466 cookit_quality() {
pankso@9 467 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
pankso@15 468 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
pankso@9 469 fi
pankso@9 470 # ERROR can be echoed any time in cookit()
pankso@33 471 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@17 472 debug_info | tee -a $LOGS/$pkg.log
pankso@33 473 rm -f $command && exit 1
pankso@1 474 fi
pankso@1 475 }
pankso@1 476
pankso@16 477 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
paul@62 478 # but it doesn't handle EXTRAVERSION.
pankso@1 479 packit() {
pankso@1 480 set_paths
pankso@55 481 echo "Pack: $PACKAGE $VERSION"
pankso@1 482 separator
pankso@44 483 if grep -q ^genpkg_rules $receipt; then
pankso@16 484 gettext -e "Executing: genpkg_rules\n"
pankso@16 485 cd $pkgdir
pankso@98 486 mkdir -p $fs && genpkg_rules || echo -e \
pankso@98 487 "\nERROR: genpkg_rules failed\n" >> $LOGS/$pkg.log
pankso@16 488 fi
pankso@98 489
pankso@98 490 # First QA check to stop now if genpkg_rules failed.
pankso@98 491 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@98 492 exit 1
pankso@98 493 fi
pankso@98 494
pankso@44 495 cd $taz
pankso@1 496 for file in receipt description.txt
pankso@1 497 do
pankso@1 498 [ ! -f "../$file" ] && continue
pankso@1 499 gettext "Copying"; echo -n " $file..."
pankso@1 500 cp -f ../$file $pack && chown 0.0 $pack/$file && status
pankso@1 501 done
pankso@119 502 copy_generic_files
pankso@16 503
paul@62 504 # Create files.list with redirecting find output.
pankso@16 505 gettext "Creating the list of files..." && cd $fs
pankso@16 506 find . -type f -print > ../files.list
pankso@16 507 find . -type l -print >> ../files.list
pankso@16 508 cd .. && sed -i s/'^.'/''/ files.list
pankso@16 509 status
pankso@43 510
pankso@119 511 # Strip and stuff files.
pankso@43 512 strip_package
pankso@43 513
pankso@43 514 # Md5sum of files.
pankso@16 515 gettext "Creating md5sum of files..."
pankso@16 516 while read file; do
pankso@16 517 [ -L "fs$file" ] && continue
pankso@16 518 [ -f "fs$file" ] || continue
pankso@16 519 case "$file" in
pankso@16 520 /lib/modules/*/modules.*|*.pyc) continue;;
pankso@16 521 esac
pankso@16 522 md5sum "fs$file" | sed 's/ fs/ /'
pankso@16 523 done < files.list > md5sum
pankso@16 524 status
pankso@16 525 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
pankso@16 526 description.txt 2> /dev/null | awk \
pankso@16 527 '{ sz=$1 } END { print sz }')
pankso@16 528
pankso@16 529 # Build cpio archives.
pankso@16 530 gettext "Compressing the fs... "
pankso@16 531 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
pankso@16 532 rm -rf fs
pankso@16 533 status
pankso@16 534 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
pankso@16 535 md5sum description.txt 2> /dev/null | awk \
pankso@16 536 '{ sz=$1 } END { print sz }')
pankso@16 537 gettext "Updating receipt sizes..."
pankso@16 538 sed -i s/^PACKED_SIZE.*$// receipt
pankso@16 539 sed -i s/^UNPACKED_SIZE.*$// receipt
pankso@16 540 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
pankso@16 541 status
pankso@16 542
pankso@16 543 # Set extra version.
pankso@16 544 if [ "$EXTRAVERSION" ]; then
pankso@16 545 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
pankso@16 546 sed -i s/^EXTRAVERSION.*$// receipt
pankso@16 547 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
pankso@16 548 status
pankso@16 549 fi
pankso@16 550
pankso@16 551 # Compress.
pankso@16 552 gettext "Creating full cpio archive... "
pankso@16 553 find . -print | cpio -o -H newc --quiet > \
pankso@16 554 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
pankso@16 555 status
pankso@16 556 gettext "Restoring original package tree... "
pankso@16 557 unlzma -c fs.cpio.lzma | cpio -idm --quiet
pankso@16 558 status
pankso@16 559 rm fs.cpio.lzma && cd ..
pankso@43 560
pankso@43 561 # QA and give info.
pankso@43 562 tazpkg=$(ls *.tazpkg)
pankso@43 563 packit_quality
pankso@43 564 separator && gettext "Package:"; echo -e " $tazpkg\n"
pankso@1 565 }
pankso@1 566
paul@62 567 # Verify package quality and consistency.
pankso@8 568 packit_quality() {
pankso@33 569 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@32 570 rm -f $command && exit 1
pankso@8 571 fi
pankso@44 572 gettext "QA: Checking for empty package..."
pankso@45 573 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
pankso@45 574 if [ "$files" -lt 0 ] && [ "$CATEGORY" != "meta" ]; then
pankso@44 575 echo -e "\nERROR: empty package"
pankso@32 576 rm -f $command && exit 1
pankso@8 577 else
pankso@134 578 # Ls sort by name so the first file is the one we want.
pankso@136 579 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
pankso@134 580 status
pankso@135 581 [ "$old" ] && echo -n "Removing old: $(basename $old)" && \
pankso@135 582 rm -f $old && status
pankso@134 583 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
pankso@11 584 sed -i /^${pkg}$/d $broken
pankso@8 585 fi
pankso@8 586 }
pankso@8 587
pankso@1 588 #
pankso@1 589 # Commands
pankso@1 590 #
pankso@1 591
pankso@1 592 case "$1" in
pankso@32 593 usage|help|-u|-h)
pankso@1 594 usage ;;
pankso@1 595 list-wok)
pankso@52 596 gettext -e "\nList of packages in:"; echo " $WOK"
pankso@1 597 separator
pankso@1 598 cd $WOK && ls -1
pankso@1 599 separator
pankso@1 600 echo -n "Packages: " && ls | wc -l
pankso@1 601 echo "" ;;
pankso@69 602 search)
pankso@69 603 # Just a simple search function, we dont need more actually.
pankso@69 604 query="$2"
pankso@69 605 gettext -e "\nSearch results for:"; echo " $query"
pankso@69 606 separator
pankso@69 607 cd $WOK && ls -1 | grep "$query"
pankso@69 608 separator && echo "" ;;
pankso@1 609 setup)
pankso@1 610 # Setup a build environment
pankso@1 611 check_root
pankso@11 612 echo "Cook: setting up the environment" | log
pankso@1 613 gettext -e "\nSetting up your environment\n"
pankso@1 614 separator && cd $SLITAZ
pankso@52 615 init_db_files
pankso@1 616 gettext -e "Checking for packages to install...\n"
pankso@29 617 for pkg in $SETUP_PKGS
pankso@1 618 do
pankso@52 619 [ ! -f "$INSTALLED/$pkg/receipt" ] && tazpkg get-install $pkg
pankso@1 620 done
pankso@1 621
pankso@1 622 # Handle --options
pankso@1 623 case "$2" in
pankso@49 624 --wok|-w)
pankso@52 625 [ ! -f "$INSTALLED/mercurial/receipt" ] && \
pankso@52 626 tazpkg get-install mercurial
paul@62 627 [ -d "$WOK" ] && echo -e "A wok already exists.\n" && exit 1
pankso@1 628 hg clone $HG_URL ;;
pankso@1 629 esac
pankso@1 630
pankso@1 631 # SliTaz group and permissions
pankso@1 632 if ! grep -q ^slitaz /etc/group; then
pankso@1 633 gettext -e "Adding group: slitaz\n"
pankso@1 634 addgroup slitaz
pankso@1 635 fi
pankso@1 636 gettext -e "Setting permissions for slitaz group...\n"
pankso@1 637 chown -R root.slitaz $SLITAZ
pankso@1 638 chmod -R g+w $SLITAZ
pankso@1 639 separator
pankso@1 640 gettext -e "All done, ready to cook packages :-)\n\n" ;;
pankso@9 641 test)
pankso@9 642 # Test a cook environment.
pankso@13 643 echo "Cook test: testing the cook environment" | log
pankso@9 644 [ ! -d "$WOK" ] && exit 1
pankso@9 645 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
pankso@9 646 cook cooktest ;;
pankso@1 647 new)
pankso@1 648 # Create the package folder and an empty receipt.
pankso@1 649 pkg="$2"
pankso@1 650 [ "$pkg" ] || usage
pankso@60 651 [ -d "${WOK}-hg" ] && WOK=${WOK}-hg
pankso@1 652 echo ""
pankso@1 653 if [ -d "$WOK/$pkg" ]; then
paul@62 654 echo -n "$pkg " && gettext "package already exists."
pankso@1 655 echo -e "\n" && exit 1
pankso@1 656 fi
pankso@1 657 gettext "Creating"; echo -n " $WOK/$pkg"
pankso@1 658 mkdir $WOK/$pkg && cd $WOK/$pkg && status
pankso@1 659 gettext "Preparing the package receipt..."
pankso@1 660 cp $DATA/receipt .
pankso@1 661 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
pankso@1 662 status && echo "" ;;
pankso@1 663 list)
pankso@1 664 # Cook a list of packages (better use the Cooker since it will order
pankso@1 665 # packages before executing cook).
pankso@1 666 check_root
pankso@1 667 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
pankso@1 668 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
pankso@1 669 echo -e " $2\n" && exit 1
pankso@13 670 echo "Cook list starting: $2" | log
pankso@1 671 for pkg in $(cat $2)
pankso@1 672 do
pankso@1 673 cook $pkg || broken
pankso@1 674 done ;;
pankso@1 675 clean-wok)
pankso@1 676 check_root
pankso@1 677 gettext -e "\nCleaning all packages files..."
pankso@1 678 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
pankso@1 679 status && echo "" ;;
pankso@1 680 clean-src)
pankso@1 681 check_root
paul@62 682 gettext -e "\nCleaning all packages sources..."
pankso@1 683 rm -rf $WOK/*/source
pankso@1 684 status && echo "" ;;
pankso@1 685 pkglist)
paul@62 686 # Create suitable packages list for TazPKG and only for built packages.
pankso@1 687 [ "$2" ] && PKGS="$2"
pankso@1 688 [ ! -d "$PKGS" ] && \
paul@62 689 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1
pankso@133 690 echo "cook:pkglist" > $command
paul@62 691 echo "Cook pkglist: Creating all packages lists" | log
pankso@1 692 gettext -e "\nCreating lists for:"; echo " $PKGS"
pankso@1 693 separator
pankso@133 694 cd $PKGS
pankso@1 695 rm -f packages.* files.list*
pankso@1 696 gettext -e "Creating: packages.list\n"
pankso@85 697 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
pankso@1 698 gettext -e "Creating: packages.md5\n"
pankso@1 699 md5sum *.tazpkg > $PKGS/packages.md5
pankso@1 700 gettext -e "Creating: packages.desc\n"
pankso@1 701 gettext -e "Creating: packages.equiv\n"
pankso@1 702 cd $WOK
pankso@1 703 for pkg in *
pankso@1 704 do
pankso@1 705 unset_receipt
pankso@1 706 . $pkg/receipt
pankso@1 707 # packages.desc let us search easily in DB
pankso@1 708 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 709 cat >> $PKGS/packages.desc << EOT
pankso@1 710 $PACKAGE | $VERSION$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
pankso@1 711 EOT
pankso@1 712 # Packages.equiv is used by tazpkg install to check depends.
pankso@1 713 for i in $PROVIDE; do
pankso@1 714 DEST=""
pankso@1 715 echo $i | fgrep -q : && DEST="${i#*:}:"
pankso@1 716 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
pankso@1 717 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
pankso@1 718 $PKGS/packages.equiv
pankso@1 719 else
pankso@1 720 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
pankso@1 721 fi
pankso@1 722 done
pankso@1 723 fi
pankso@1 724 done
pankso@1 725 # files.list.lzma
pankso@1 726 #lzma e files.list files.list.lzma
pankso@1 727 separator
pankso@1 728 nb=$(ls $PKGS/*.tazpkg | wc -l)
pankso@133 729 echo -e "Packages: $nb\n"
pankso@133 730 rm -f $command ;;
pankso@1 731 *)
pankso@1 732 # Just cook and generate a package.
pankso@1 733 check_root
pankso@1 734 time=$(date +%s)
pankso@1 735 pkg="$1"
pankso@1 736 [ -z "$pkg" ] && usage
pankso@44 737 receipt="$WOK/$pkg/receipt"
pankso@1 738 check_pkg_in_wok && echo ""
pankso@47 739
pankso@128 740 # Display and log info if cook process stopped.
pankso@128 741 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
pankso@128 742 tee -a $LOGS/$pkg.log' INT
pankso@128 743
pankso@47 744 # Skip blocked, 3 lines also for the Cooker.
pankso@51 745 if grep -q "^$pkg$" $blocked && [ "$2" != "--*" ]; then
pankso@47 746 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
pankso@47 747 fi
pankso@47 748
pankso@47 749 # Log and source receipt.
pankso@56 750 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
pankso@16 751 echo "cook:$pkg" > $command
pankso@1 752 unset inst
pankso@1 753 unset_receipt
pankso@44 754 . $receipt
pankso@1 755
pankso@1 756 # Handle --options
pankso@1 757 case "$2" in
pankso@1 758 --clean|-c)
pankso@49 759 gettext -e "Cleaning:"; echo -n " $pkg"
pankso@1 760 cd $WOK/$pkg && rm -rf install taz source
pankso@1 761 status && echo "" && exit 0 ;;
pankso@1 762 --install|-i)
pankso@1 763 inst='yes' ;;
pankso@49 764 --getsrc|-gs)
pankso@49 765 gettext "Getting source for:"; echo " $pkg"
pankso@45 766 separator && get_source
pankso@39 767 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
pankso@49 768 --block|-b)
pankso@49 769 gettext "Blocking:"; echo -n " $pkg"
pankso@49 770 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
pankso@49 771 status && echo "" && exit 0 ;;
pankso@49 772 --unblock|-ub)
pankso@49 773 gettext "Unblocking:"; echo -n " $pkg"
pankso@49 774 sed -i "/^${pkg}$/"d $blocked
pankso@49 775 status && echo "" && exit 0 ;;
pankso@1 776 esac
pankso@1 777
paul@62 778 # Check if wanted is built now so we have separate log files.
pankso@1 779 if [ "$WANTED" ] && [ ! -d "$WOK/$WANTED/install" ]; then
pankso@137 780 if ! grep -q "^$WANTED$" $broken
pankso@137 781 cook "$WANTED"
pankso@137 782 fi
pankso@1 783 fi
pankso@1 784
pankso@1 785 # Cook and pack or exit on error and log everything.
pankso@97 786 cookit $@ 2>&1 | tee $LOGS/$pkg.log
pankso@15 787 remove_deps | tee -a $LOGS/$pkg.log
pankso@1 788 cookit_quality
pankso@26 789 packit 2>&1 | tee -a $LOGS/$pkg.log
pankso@1 790 clean_log
pankso@33 791
pankso@33 792 # Exit if any error in packing.
pankso@33 793 if grep -q ^ERROR $LOGS/$pkg.log; then
pankso@33 794 debug_info | tee -a $LOGS/$pkg.log
pankso@33 795 rm -f $command && exit 1
pankso@33 796 fi
pankso@16 797
pankso@1 798 # Time and summary
pankso@1 799 time=$(($(date +%s) - $time))
pankso@1 800 summary | tee -a $LOGS/$pkg.log
pankso@50 801 echo ""
pankso@1 802
pankso@1 803 # Install package if requested
pankso@1 804 if [ "$inst" ]; then
pankso@1 805 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 806 cd $PKGS && tazpkg install \
pankso@1 807 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
pankso@1 808 else
paul@62 809 gettext -e "Unable to install package, build has failed.\n\n"
pankso@1 810 exit 1
pankso@1 811 fi
pankso@1 812 fi
pankso@9 813 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
pankso@17 814 # You want automation: use the Cooker Build Bot.
pankso@1 815 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
pankso@18 816 rm -f $command ;;
pankso@1 817 esac
pankso@1 818
pankso@1 819 exit 0